{ (c) by Igor Dikshew // Uni Tula }

UNIT SPISOC;

INTERFACE

USES InsConst;

PROCEDURE NewRecord;  {  ᯨ᪠}
PROCEDURE AddFirst; {ᮧ ࢮ ꥪ  ᯨ᪥}
PROCEDURE Adding (VAR A : InsConst_LINK);  { , ᫥ ꥪ A}
PROCEDURE DelFirst (VAR A : InsConst_LINK); { ࢮ ꥪ  ᯨ᪠}
PROCEDURE Killer (VAR A : InsConst_LINK);  { ꥪ  ᯨ᪠}
PROCEDURE DoneRecord;  {  ᯨ᪠}

IMPLEMENTATION

PROCEDURE NewRecord;  {  ᯨ᪠}
BEGIN
  NEW (InsConst_HEADER);             {ࠧ頥  ᯨ᪠  }
  InsConst_HEADER^.FATER := InsConst_HEADER;  { ।}
  InsConst_HEADER^.NEXT  := InsConst_HEADER;  { ᫥}
END;

PROCEDURE AddFirst; {ᮧ ࢮ ꥪ  ᯨ᪥}
VAR
  A : InsConst_LINK;
BEGIN
  NEW (A);  {ᮧ  ꥪ}
  A^.FATER := InsConst_Header; {  ।  Header}
  A^.NEXT := InsConst_Header^.NEXT; { ᫥  ᫥ Header}
  InsConst_Header^.NEXT^.FATER := A;
  InsConst_Header^.NEXT := A;  {ꥪ A ⠭ ᫥ ꥪ Header}
END;

PROCEDURE Adding (VAR A : InsConst_LINK);  { , ᫥ ꥪ A}
VAR
  P : InsConst_LINK;
BEGIN
  NEW (P); {ᮧ  ꥪ}
  P^.FATER := A;       {  ।  ꥪ A}
  P^.NEXT := A^.NEXT;  {᫥   ꥪ A}
  A^.NEXT^.FATER := P;
  A^.NEXT := P;        { ᠬ ⠭ ᫥ ꥪ A}
END;

PROCEDURE DelFirst (VAR A : InsConst_LINK); { ࢮ ꥪ  ᯨ᪠}
BEGIN
  InsConst_Header^.NEXT := A^.NEXT; { ⠭ ᫥ }
  A^.NEXT^.FATER := InsConst_Header; {।   ⠭ ᠬ }
  DISPOSE (A); {㭨⮦ ꥪ A  }
END;


PROCEDURE Killer (VAR A : InsConst_LINK);  { ꥪ  ᯨ᪠}
BEGIN
  A^.FATER^.NEXT := A^.NEXT;
  A^.NEXT^.FATER := A^.FATER;
  DISPOSE (A);
END;

PROCEDURE DoneRecord;  {  ᯨ᪠}
BEGIN
  DISPOSE (InsConst_HEADER);             {ࠧ頥  ᯨ᪠  }
END;

END.
